<template>
  <Modal v-model="showModalObjRole" :mask-closable="false" :closable="false" :title="modalTitle" :value="value"
         width="820" v-draggable="options">

    <i-form label-position="right" :label-width="100" ref="objRoleForm" :model="bean" :rules="rules" inline>
      <Row>
        <i-col :span="12">
          <Form-item label="对象名称" prop="objName" class="ivu-form-item-search">
            <Input v-model="bean.objName" style="width: 243px;" disabled></Input>
          </Form-item>
        </i-col>
        <i-col :span="12">
          <Form-item label="对象类型" prop="objType" class="ivu-form-item-search">
            <Select v-model="bean.objType" style="width: 243px;" disabled>
              <Option :value="1" :key="1">用户</Option>
              <Option :value="2" :key="2">机构</Option>
              <Option :value="3" :key="3">用户组</Option>
            </Select>
          </Form-item>
        </i-col>
        <i-col :span="12">
          <Form-item label="选择角色" class="ivu-form-item-search">
            <Button type="primary" size="small" @click="checkRole" ghost :disabled="disabled">点击选择</Button>
          </Form-item>
        </i-col>
        <i-col :span="12">
          <Form-item label="角色编码" prop="roleCode" class="ivu-form-item-search">
            <Input v-model="bean.roleCode" style="width: 243px;" disabled></Input>
          </Form-item>
        </i-col>
        <i-col :span="12">
          <Form-item label="角色名称" prop="roleName" class="ivu-form-item-search">
            <Input v-model="bean.roleName" style="width: 243px;" disabled></Input>
          </Form-item>
        </i-col>
        <i-col :span="12">
          <Form-item label="备注" prop="remark" class="ivu-form-item-search">
            <Input v-model="bean.remark" style="width: 243px;" :disabled="disabled"></Input>
          </Form-item>
        </i-col>
      </Row>
    </i-form>
    <template #footer>
    <div>
      <Button @click="cancel">关闭</Button>
      <Button type="primary" :loading="saveLoading" @click="ok('objRoleForm')" v-if="showSaveBtn">保存</Button>
    </div>
    </template>
    <bc-check ref="checkRole" :show.sync="checkRoleShow" :treeData="roles" @checkOk="checkedRoleOk" :treeId="'checkRole'" ></bc-check>
  </Modal>
</template>

<script>
  import { addObjRole, editObjRole } from '../../../../api/rbac/obj-role-api'
  import { getRoleTree } from '../../../../api/rbac/role-api'

  let $this
  export default {
    name: 'objRoleModal',
    components: {},
    props: {
      show: Boolean,
      value: Object
    },
    data () {
      return {
        checkRoleShow: false,
        roles: [],
        showModalObjRole: false,
        bean: {},
        initBean: {},
        flag: '',
        saveLoading: false,
        modalTitle: '',
        disabled: false,
        showSaveBtn: true,
        rules: {
          objName: [
            { required: true, message: '对象名称不能为空!', trigger: 'blur' },
          ],
          roleCode: [
            { required: true, message: '角色编码不能为空!', trigger: 'blur' },
          ],
          roleName: [
            { required: true, message: '角色名称不能为空!', trigger: 'blur' },
          ],
        },
        options: {
          trigger: '.ivu-modal-header',
          body: '.ivu-modal',
          recover: true
        }
      }
    }, methods: {
      ok (name) {
        this.$refs[name].validate((valid) => {
          if (!valid) {
            return
          }//表单校验失败则返回
          this.saveLoading = true
          //this.showModalObjRole = false;
          if (this.flag == 'edit') {
            let parmas = this.bean
            delete parmas['createTime']
            delete parmas['modifyTime']
            //执行修改操作
            editObjRole(parmas).then(data => {
              if (!data.status) {
                this.$Message.error(data.error.message)
                this.saveLoading = false
                console.log(data)
                return false
              }
              this.$Message.success('操作成功！')
              this.closeAndRefresh()
            }).catch(err => {
              this.$Message.error('操作失败！')
              this.saveLoading = false
              console.log(err)
            })
          } else if (this.flag == 'add') {
            delete this.bean['createTime']
            delete this.bean['modifyTime']
            //执行添加操作
            addObjRole(this.bean).then(data => {
              if (!data.status) {
                this.$Message.error(data.error.message)
                this.saveLoading = false
                console.log(data)
                return false
              }
              this.$Message.success('操作成功！')
              this.closeAndRefresh()
            }).catch(err => {
              this.$Message.error('操作失败！')
              this.saveLoading = false
              console.log(err)
            })
          }
        })

      },
      cancel () {
        this.showModalObjRole = false
        this.$emit('update:show', false)
        //重置校验结果
        this.$refs['objRoleForm'].resetFields()
      },
      closeAndRefresh () {
        this.saveLoading = false
        this.cancel()
        this.$emit('reload-data')
      },
      checkRole (){//选择角色
        this.checkRoleShow=true;
        getRoleTree().then(res => {
          this.roles = res.data.result;
        });
      },
      checkedRoleOk (checkedRoles){//选择角色-完成
        this.bean.roleId = checkedRoles[0].id
        this.bean.roleCode = checkedRoles[0].code
        this.bean.roleName = checkedRoles[0].name

        this.$forceUpdate();
      },
    },
    mounted () {
      $this = this
      this.bean = this.initBean
    },
    watch: {
      show: {
        immediate: true,
        handler: function () {
          this.showModalObjRole = this.show
        }
      },
      value: {
        immediate: true,
        handler: function () {
          //赋值
          this.bean = this.value.bean == null ? Object.assign({}, this.initBean) : JSON.parse(JSON.stringify(this.value.bean))
          this.flag = this.value.flag
          this.modalTitle = this.value.title
          //如果时查看的功能，要将所有input框只读，并且去掉保存按钮
          if (this.flag == 'view') {
            this.disabled = true
            this.showSaveBtn = false
          } else {
            this.disabled = false
            this.showSaveBtn = true
          }
        }
      }
    }

  }
</script>

<style scoped>
  .ivu-form-item-search {
    margin-bottom: 21px;
  }
</style>
